diff --git a/src/preprocessors/spp_stream5.c b/src/preprocessors/spp_stream5.c
index bbf1eeb..d40104d 100644
--- a/src/preprocessors/spp_stream5.c
+++ b/src/preprocessors/spp_stream5.c
@@ -2770,6 +3125,8 @@ static void Stream5GlobalReload(char *args)
     pCurrentPolicyConfig->global_config->max_tcp_sessions = S5_DEFAULT_MAX_TCP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_udp_sessions = S5_TRACK_YES;
     pCurrentPolicyConfig->global_config->max_udp_sessions = S5_DEFAULT_MAX_UDP_SESSIONS;
+    pCurrentPolicyConfig->global_config->track_sctp_sessions = S5_TRACK_YES;
+    pCurrentPolicyConfig->global_config->max_sctp_sessions = S5_DEFAULT_MAX_SCTP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_icmp_sessions = S5_TRACK_NO;
     pCurrentPolicyConfig->global_config->max_icmp_sessions = S5_DEFAULT_MAX_ICMP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_ip_sessions = S5_TRACK_NO;
@@ -2788,11 +3145,12 @@ static void Stream5GlobalReload(char *args)
     if ((!pCurrentPolicyConfig->global_config->disabled) &&
         (pCurrentPolicyConfig->global_config->track_tcp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_udp_sessions == S5_TRACK_NO) &&
+        (pCurrentPolicyConfig->global_config->track_sctp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_icmp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_ip_sessions == S5_TRACK_NO))
     {
         FatalError("%s(%d) ==> Stream5 enabled, but not configured to track "
-                   "TCP, UDP, ICMP, or IP.\n", file_name, file_line);
+                   "TCP, UDP, SCTP, ICMP, or IP.\n", file_name, file_line);
     }
 
     if (policy_id != getDefaultPolicy())
@@ -2801,6 +3159,8 @@ static void Stream5GlobalReload(char *args)
             pDefaultPolicyConfig->global_config->max_tcp_sessions;
         pCurrentPolicyConfig->global_config->max_udp_sessions =
             pDefaultPolicyConfig->global_config->max_udp_sessions;
+        pCurrentPolicyConfig->global_config->max_sctp_sessions =
+            pDefaultPolicyConfig->global_config->max_sctp_sessions;
         pCurrentPolicyConfig->global_config->max_icmp_sessions =
             pDefaultPolicyConfig->global_config->max_icmp_sessions;
         pCurrentPolicyConfig->global_config->max_ip_sessions =
@@ -2869,6 +3229,28 @@ static void Stream5UdpReload(char *args)
     Stream5UdpPolicyInit(config->udp_config, args);
 }
 
+static void Stream5SctpReload(char *args)
+{
+    tSfPolicyId policy_id = getParserPolicy();
+    Stream5Config *config;
+
+    if (s5_swap_config == NULL)
+        FatalError("Tried to config stream5 SCTP policy without global config!\n");
+
+    config = (Stream5Config *)sfPolicyUserDataGet(s5_swap_config, policy_id);
+
+    if ((config == NULL) || (config->global_config == NULL))
+    {
+        FatalError("Tried to config stream5 SCTP policy without global config!\n");
+    }
+
+    if (config->sctp_config == NULL)
+        config->sctp_config = (Stream5SctpConfig *)SnortAlloc(sizeof(Stream5SctpConfig));
+
+    /* Call the protocol specific initializer */
+    Stream5SctpPolicyInit(config->sctp_config, args);
+}
+
 static void Stream5IcmpReload(char *args)
 {
     tSfPolicyId policy_id = getParserPolicy();
@@ -2967,6 +3349,7 @@ static int Stream5ReloadVerifyPolicy(
     Stream5Config *sc = (Stream5Config *)sfPolicyUserDataGet(s5_swap_config, policyId);
     int tcpNotConfigured = 0;
     int udpNotConfigured = 0;
+    int sctpNotConfigured = 0;
     int icmpNotConfigured = 0;
     int ipNotConfigured = 0;
     int proto_flags = 0;
@@ -2983,10 +3366,11 @@ static int Stream5ReloadVerifyPolicy(
 
         if ((sc->global_config->track_tcp_sessions != cc->global_config->track_tcp_sessions) ||
                 (sc->global_config->track_udp_sessions != cc->global_config->track_udp_sessions) ||
+                (sc->global_config->track_sctp_sessions != cc->global_config->track_sctp_sessions) ||
                 (sc->global_config->track_icmp_sessions != cc->global_config->track_icmp_sessions) ||
                 (sc->global_config->track_ip_sessions != cc->global_config->track_ip_sessions))
         {
-            ErrorMessage("Stream5 Reload: Changing tracking of TCP, UDP ICMP, or IP "
+            ErrorMessage("Stream5 Reload: Changing tracking of TCP, UDP, SCTP, ICMP, or IP "
                     "sessions requires a restart.\n");
             Stream5FreeConfigs(s5_swap_config);
             s5_swap_config = NULL;
@@ -3017,6 +3401,14 @@ static int Stream5ReloadVerifyPolicy(
             return -1;
         }
 
+        if (sc->global_config->max_sctp_sessions != cc->global_config->max_sctp_sessions)
+        {
+            ErrorMessage("Stream5 Reload: Changing \"max_sctp\" requires a restart.\n");
+            Stream5FreeConfigs(s5_swap_config);
+            s5_swap_config = NULL;
+            return -1;
+        }
+
         if (cc->global_config->max_icmp_sessions != sc->global_config->max_icmp_sessions)
         {
             ErrorMessage("Stream5 Reload: Changing \"max_icmp\" requires a restart.\n");
@@ -3075,6 +3467,25 @@ static int Stream5ReloadVerifyPolicy(
         }
     }
 
+    if (sc->global_config->track_sctp_sessions)
+    {
+        sctpNotConfigured =
+            !sc->global_config->max_sctp_sessions ||
+            Stream5VerifySctpConfig(sc->sctp_config, policyId);
+
+        if (sctpNotConfigured)
+        {
+            ErrorMessage("WARNING: Stream5 SCTP misconfigured\n");
+        }
+        else
+        {
+            if ( !(s_proto_flags & PROTO_BIT__SCTP) )
+                s_sctp_sessions += sc->global_config->max_sctp_sessions;
+
+            proto_flags |= PROTO_BIT__SCTP;
+        }
+    }
+
     if (sc->global_config->track_icmp_sessions)
     {
         icmpNotConfigured =
diff --git a/src/preprocessors/stream_api.h b/src/preprocessors/stream_api.h
index 9932152..7efadef 100644
--- a/src/preprocessors/stream_api.h
+++ b/src/preprocessors/stream_api.h
@@ -23,7 +23,7 @@
 /* stream_api.h
  *
  * Purpose: Definition of the StreamAPI.  To be used as a common interface
- *          for TCP (and later UDP & ICMP) Stream access for other
+ *          for TCP (and later UDP, SCTP, & ICMP) Stream access for other
  *          preprocessors and detection plugins.
  *
  * Arguments:
diff --git a/src/rule_option_types.h b/src/rule_option_types.h
index e9841ac..a7dccfa 100644
--- a/src/rule_option_types.h
+++ b/src/rule_option_types.h
@@ -64,13 +64,17 @@ typedef enum _option_type_t
     RULE_OPTION_TYPE_TCP_SEQ,
     RULE_OPTION_TYPE_TCP_WIN,
     RULE_OPTION_TYPE_TTL,
-    RULE_OPTION_TYPE_URILEN
+    RULE_OPTION_TYPE_URILEN,
 #ifdef DYNAMIC_PLUGIN
-    ,
     RULE_OPTION_TYPE_HDR_OPT_CHECK,
     RULE_OPTION_TYPE_PREPROCESSOR,
-    RULE_OPTION_TYPE_DYNAMIC
+    RULE_OPTION_TYPE_DYNAMIC,
 #endif
+    RULE_OPTION_TYPE_SCTP_CHUNK_TYPE,
+    RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS,
+    RULE_OPTION_TYPE_SCTP_CHUNK_FIELD,
+    RULE_OPTION_TYPE_SCTP_NUM_CHUNKS,
+    RULE_OPTION_TYPE_SCTP_CAUSE_CODE,
 } option_type_t;
 
 #endif /* RULE_OPTION_TYPES__H */
diff --git a/src/sf_protocols.h b/src/sf_protocols.h
index ca89f95..36a4622 100644
--- a/src/sf_protocols.h
+++ b/src/sf_protocols.h
@@ -35,6 +35,8 @@ typedef enum {
     PROTO_TCP,        // DecodeTCP
                       // DecodeTCPOptions - handled with TCP
 
+    PROTO_SCTP,       // DecodeSCTP
+
     PROTO_IP6,        // DecodeIPV6
                       // DecodeIPV6Extensions - nothing to do here, calls below
     PROTO_IP6_HOP_OPTS,  // DecodeIPV6Options - ip6 hop, dst, rte, and frag exts
diff --git a/src/sfutil/Makefile.am b/src/sfutil/Makefile.am
index 2432f72..6e95bad 100644
--- a/src/sfutil/Makefile.am
+++ b/src/sfutil/Makefile.am
@@ -50,6 +50,7 @@ libsfutil_a_SOURCES = \
     sf_base64decode.c sf_base64decode.h \
     Unified2_common.h \
     sf_seqnums.h \
+    adler32.c adler32.h \
     $(INTEL_SOFT_CPM_SOURCES)
 
 INCLUDES = @INCLUDES@
diff --git a/src/sfutil/adler32.c b/src/sfutil/adler32.c
new file mode 100644
index 0000000..adcae1c
--- /dev/null
+++ b/src/sfutil/adler32.c
@@ -0,0 +1,59 @@
+/* adler32.c
+ * Compute the Adler32 checksum (RFC 1950)
+ * Based on code from RFC 1950 (Chapter 9. Appendix: Sample code)
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+/*
+ * Borrwed from Wireshark.  Hey, it's GPLv2!
+ * Original by Gerald Combs <gerald () wireshark org>
+ * Original Copyright 1998 Gerald Combs
+ *                    2003 Tomas Kukosa
+ */
+
+#include <string.h>
+
+#include "adler32.h"
+
+#define BASE 65521 /* largest prime smaller than 65536 */
+
+/*--- update_adler32 --------------------------------------------------------*/
+unsigned long update_adler32(unsigned long adler, const unsigned char *buf, int len)
+{
+  unsigned long s1 = adler & 0xffff;
+  unsigned long s2 = (adler >> 16) & 0xffff;
+  int n;
+
+  for (n = 0; n < len; n++) {
+    s1 = (s1 + buf[n]) % BASE;
+    s2 = (s2 + s1)     % BASE;
+  }
+  return (s2 << 16) + s1;
+}
+
+/*--- adler32 ---------------------------------------------------------------*/
+unsigned long adler32_bytes(const unsigned char *buf, int len)
+{
+  return update_adler32(1L, buf, len);
+}
+
+/*--- adler32_str -----------------------------------------------------------*/
+unsigned long adler32_str(const char *buf)
+{
+  return update_adler32(1L, (const unsigned char*)buf, (int)strlen(buf));
+}
+
+/*---------------------------------------------------------------------------*/
diff --git a/src/sfutil/adler32.h b/src/sfutil/adler32.h
new file mode 100644
index 0000000..81deb98
--- /dev/null
+++ b/src/sfutil/adler32.h
@@ -0,0 +1,41 @@
+/* adler32.h
+ * Compute the Adler32 checksum (RFC 1950)
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+ */
+
+/*
+ * Borrwed from Wireshark.  Hey, it's GPLv2!
+ * Original by Gerald Combs <gerald () wireshark org>
+ * Original Copyright 1998 Gerald Combs
+ *                    2003 Tomas Kukosa
+ */
+
+#ifndef ADLER32_H
+#define ADLER32_H
+
+#ifdef __cplusplus
+extern "C"{
+#endif
+
+unsigned long update_adler32(unsigned long adler, const unsigned char *buf, int len);
+unsigned long adler32_bytes(const unsigned char *buf, int len);
+unsigned long adler32_str(const char *buf);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif  /* ADLER32_H */
diff --git a/src/sfutil/crc32.h b/src/sfutil/crc32.h
new file mode 100644
index 0000000..9629223
--- /dev/null
+++ b/src/sfutil/crc32.h
@@ -0,0 +1,129 @@
+/* crc32.c
+ * CRC-32 routine
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ */
+
+/*
+ * Borrwed from Wireshark.  Hey, it's GPLv2!
+ * Original by Gerald Combs <gerald () wireshark org>
+ * Original Copyright 1998 Gerald Combs
+ *
+ * Credits:
+ * Table from Solomon Peachy
+ * Routine from Chris Waters
+ */
+
+#ifndef _CRC32_H_
+#define _CRC32_H_
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+
+
+/*****************************************************************/
+/*                                                               */
+/* CRC32C LOOKUP TABLE                                           */
+/* +++================                                           */
+/* The following CRC lookup table was generated automagically    */
+/* by the Rocksoft^tm Model CRC Algorithm Table Generation       */
+/* Program V1.0 using the following model parameters:            */
+/*                                                               */
+/*    Width   : 4 bytes.                                         */
+/*    Poly    : 0x1EDC6F41L                                      */
+/*    Reverse : TRUE.                                            */
+/*                                                               */
+/* For more information on the Rocksoft^tm Model CRC Algorithm,  */
+/* see the document titled "A Painless Guide to CRC Error        */
+/* Detection Algorithms" by Ross Williams                        */
+/* (ross () guest adelaide edu au.). This document is likely to be  */
+/* in the FTP archive "ftp.adelaide.edu.au/pub/rocksoft".        */
+/*                                                               */
+/*****************************************************************/
+const unsigned long crc32c_table[256] = {
+        0x00000000L, 0xF26B8303L, 0xE13B70F7L, 0x1350F3F4L, 0xC79A971FL,
+        0x35F1141CL, 0x26A1E7E8L, 0xD4CA64EBL, 0x8AD958CFL, 0x78B2DBCCL,
+        0x6BE22838L, 0x9989AB3BL, 0x4D43CFD0L, 0xBF284CD3L, 0xAC78BF27L,
+        0x5E133C24L, 0x105EC76FL, 0xE235446CL, 0xF165B798L, 0x030E349BL,
+        0xD7C45070L, 0x25AFD373L, 0x36FF2087L, 0xC494A384L, 0x9A879FA0L,
+        0x68EC1CA3L, 0x7BBCEF57L, 0x89D76C54L, 0x5D1D08BFL, 0xAF768BBCL,
+        0xBC267848L, 0x4E4DFB4BL, 0x20BD8EDEL, 0xD2D60DDDL, 0xC186FE29L,
+        0x33ED7D2AL, 0xE72719C1L, 0x154C9AC2L, 0x061C6936L, 0xF477EA35L,
+        0xAA64D611L, 0x580F5512L, 0x4B5FA6E6L, 0xB93425E5L, 0x6DFE410EL,
+        0x9F95C20DL, 0x8CC531F9L, 0x7EAEB2FAL, 0x30E349B1L, 0xC288CAB2L,
+        0xD1D83946L, 0x23B3BA45L, 0xF779DEAEL, 0x05125DADL, 0x1642AE59L,
+        0xE4292D5AL, 0xBA3A117EL, 0x4851927DL, 0x5B016189L, 0xA96AE28AL,
+        0x7DA08661L, 0x8FCB0562L, 0x9C9BF696L, 0x6EF07595L, 0x417B1DBCL,
+        0xB3109EBFL, 0xA0406D4BL, 0x522BEE48L, 0x86E18AA3L, 0x748A09A0L,
+        0x67DAFA54L, 0x95B17957L, 0xCBA24573L, 0x39C9C670L, 0x2A993584L,
+        0xD8F2B687L, 0x0C38D26CL, 0xFE53516FL, 0xED03A29BL, 0x1F682198L,
+        0x5125DAD3L, 0xA34E59D0L, 0xB01EAA24L, 0x42752927L, 0x96BF4DCCL,
+        0x64D4CECFL, 0x77843D3BL, 0x85EFBE38L, 0xDBFC821CL, 0x2997011FL,
+        0x3AC7F2EBL, 0xC8AC71E8L, 0x1C661503L, 0xEE0D9600L, 0xFD5D65F4L,
+        0x0F36E6F7L, 0x61C69362L, 0x93AD1061L, 0x80FDE395L, 0x72966096L,
+        0xA65C047DL, 0x5437877EL, 0x4767748AL, 0xB50CF789L, 0xEB1FCBADL,
+        0x197448AEL, 0x0A24BB5AL, 0xF84F3859L, 0x2C855CB2L, 0xDEEEDFB1L,
+        0xCDBE2C45L, 0x3FD5AF46L, 0x7198540DL, 0x83F3D70EL, 0x90A324FAL,
+        0x62C8A7F9L, 0xB602C312L, 0x44694011L, 0x5739B3E5L, 0xA55230E6L,
+        0xFB410CC2L, 0x092A8FC1L, 0x1A7A7C35L, 0xE811FF36L, 0x3CDB9BDDL,
+        0xCEB018DEL, 0xDDE0EB2AL, 0x2F8B6829L, 0x82F63B78L, 0x709DB87BL,
+        0x63CD4B8FL, 0x91A6C88CL, 0x456CAC67L, 0xB7072F64L, 0xA457DC90L,
+        0x563C5F93L, 0x082F63B7L, 0xFA44E0B4L, 0xE9141340L, 0x1B7F9043L,
+        0xCFB5F4A8L, 0x3DDE77ABL, 0x2E8E845FL, 0xDCE5075CL, 0x92A8FC17L,
+        0x60C37F14L, 0x73938CE0L, 0x81F80FE3L, 0x55326B08L, 0xA759E80BL,
+        0xB4091BFFL, 0x466298FCL, 0x1871A4D8L, 0xEA1A27DBL, 0xF94AD42FL,
+        0x0B21572CL, 0xDFEB33C7L, 0x2D80B0C4L, 0x3ED04330L, 0xCCBBC033L,
+        0xA24BB5A6L, 0x502036A5L, 0x4370C551L, 0xB11B4652L, 0x65D122B9L,
+        0x97BAA1BAL, 0x84EA524EL, 0x7681D14DL, 0x2892ED69L, 0xDAF96E6AL,
+        0xC9A99D9EL, 0x3BC21E9DL, 0xEF087A76L, 0x1D63F975L, 0x0E330A81L,
+        0xFC588982L, 0xB21572C9L, 0x407EF1CAL, 0x532E023EL, 0xA145813DL,
+        0x758FE5D6L, 0x87E466D5L, 0x94B49521L, 0x66DF1622L, 0x38CC2A06L,
+        0xCAA7A905L, 0xD9F75AF1L, 0x2B9CD9F2L, 0xFF56BD19L, 0x0D3D3E1AL,
+        0x1E6DCDEEL, 0xEC064EEDL, 0xC38D26C4L, 0x31E6A5C7L, 0x22B65633L,
+        0xD0DDD530L, 0x0417B1DBL, 0xF67C32D8L, 0xE52CC12CL, 0x1747422FL,
+        0x49547E0BL, 0xBB3FFD08L, 0xA86F0EFCL, 0x5A048DFFL, 0x8ECEE914L,
+        0x7CA56A17L, 0x6FF599E3L, 0x9D9E1AE0L, 0xD3D3E1ABL, 0x21B862A8L,
+        0x32E8915CL, 0xC083125FL, 0x144976B4L, 0xE622F5B7L, 0xF5720643L,
+        0x07198540L, 0x590AB964L, 0xAB613A67L, 0xB831C993L, 0x4A5A4A90L,
+        0x9E902E7BL, 0x6CFBAD78L, 0x7FAB5E8CL, 0x8DC0DD8FL, 0xE330A81AL,
+        0x115B2B19L, 0x020BD8EDL, 0xF0605BEEL, 0x24AA3F05L, 0xD6C1BC06L,
+        0xC5914FF2L, 0x37FACCF1L, 0x69E9F0D5L, 0x9B8273D6L, 0x88D28022L,
+        0x7AB90321L, 0xAE7367CAL, 0x5C18E4C9L, 0x4F48173DL, 0xBD23943EL,
+        0xF36E6F75L, 0x0105EC76L, 0x12551F82L, 0xE03E9C81L, 0x34F4F86AL,
+        0xC69F7B69L, 0xD5CF889DL, 0x27A40B9EL, 0x79B737BAL, 0x8BDCB4B9L,
+        0x988C474DL, 0x6AE7C44EL, 0xBE2DA0A5L, 0x4C4623A6L, 0x5F16D052L,
+        0xAD7D5351L
+};
+
+/*
+ * Byte swap fix contributed by Dave Wysochanski <davidw () netapp com>.
+ */
+#define CRC32C_SWAP(crc32c_value)				\
+    (((crc32c_value & 0xff000000) >> 24)	|	\
+     ((crc32c_value & 0x00ff0000) >>  8)	|	\
+     ((crc32c_value & 0x0000ff00) <<  8)	|	\
+     ((crc32c_value & 0x000000ff) << 24))
+
+#define CRC32C(c,d) (c = (c >> 8) ^ crc32c_table[(c ^ (d)) & 0xFF])
+#define CRC32C_PRELOAD 0xffffffff
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* _CRC32_H_ */
diff --git a/src/sfutil/sfportobject.c b/src/sfutil/sfportobject.c
index ea6655a..bd457e5 100644
--- a/src/sfutil/sfportobject.c
+++ b/src/sfutil/sfportobject.c
@@ -91,9 +91,9 @@
    PortVar - has been added. These are always added to the PortVarTable.
 
    --- Loading Port lists and rules
-   PortTables - we support src and dst tables for tcp/udp/icmp/ip/arp rules.
+   PortTables - we support src and dst tables for tcp/udp/sctp/icmp/ip/arp rules.
    PortVar References - we dup the PortVar entries as needed into each table if referenced,
-   so HTTP_PORTS for tcp and udp contain different rules.  If a rule references a PortVar
+   so HTTP_PORTS for tcp, udp, & sctp contain different rules.  If a rule references a PortVar
    we look it up in the table, if its not present we dup it from the PortVarTable, otherwise
    we just add the rule index to the PortVar HTTP_PORTS in the proper table. If a PortVar
    is not used to specify a Port entry in a rule we create a temp port-object, and check if
diff --git a/src/sfutil/sfportobject.h b/src/sfutil/sfportobject.h
index 0679dfb..294a470 100644
--- a/src/sfutil/sfportobject.h
+++ b/src/sfutil/sfportobject.h
@@ -165,16 +165,19 @@ typedef struct {
 
     PortTable * tcp_src, * tcp_dst;
     PortTable * udp_src, * udp_dst;
+    PortTable * sctp_src, * sctp_dst;
     PortTable * icmp_src,* icmp_dst;
     PortTable * ip_src,  * ip_dst;
     
     PortObject * tcp_anyany;
     PortObject * udp_anyany;
+    PortObject * sctp_anyany;
     PortObject * icmp_anyany;
     PortObject * ip_anyany;
     
     PortObject * tcp_nocontent; 
     PortObject * udp_nocontent; 
+    PortObject * sctp_nocontent;
     PortObject * icmp_nocontent; 
     PortObject * ip_nocontent; 
 
diff --git a/src/snort.c b/src/snort.c
index e3eb77b..825eb06 100644
--- a/src/snort.c
+++ b/src/snort.c
@@ -1721,7 +1721,7 @@ static int ShowUsage(char *program_name)
     FPUTS_BOTH ("        -H         Make hash tables deterministic.\n");
     FPUTS_BOTH ("        -i <if>    Listen on interface <if>\n");
     FPUTS_BOTH ("        -I         Add Interface name to alert output\n");
-    FPUTS_BOTH ("        -k <mode>  Checksum mode (all,noip,notcp,noudp,noicmp,none)\n");
+    FPUTS_BOTH ("        -k <mode>  Checksum mode (all,noip,notcp,noudp,nosctp,noicmp,none)\n");
     FPUTS_BOTH ("        -K <mode>  Logging mode (pcap[default],ascii,none)\n");
     FPUTS_BOTH ("        -l <ld>    Log to directory <ld>\n");
     FPUTS_BOTH ("        -L <file>  Log to this tcpdump file\n");
diff --git a/src/snort.h b/src/snort.h
index 0fbddec..cf58039 100644
--- a/src/snort.h
+++ b/src/snort.h
@@ -120,7 +120,8 @@
 #define DO_IP_CHECKSUMS     0x00000001
 #define DO_TCP_CHECKSUMS    0x00000002
 #define DO_UDP_CHECKSUMS    0x00000004
-#define DO_ICMP_CHECKSUMS   0x00000008
+#define DO_SCTP_CHECKSUMS   0x00000008
+#define DO_ICMP_CHECKSUMS   0x00000010
 
 #define LOG_UNIFIED         0x00000001
 #define LOG_TCPDUMP         0x00000002
@@ -499,7 +500,8 @@ typedef enum _ChecksumFlag
     CHECKSUM_FLAG__IP   = 0x00000001,
     CHECKSUM_FLAG__TCP  = 0x00000002,
     CHECKSUM_FLAG__UDP  = 0x00000004,
-    CHECKSUM_FLAG__ICMP = 0x00000008,
+    CHECKSUM_FLAG__SCTP = 0x00000008,
+    CHECKSUM_FLAG__ICMP = 0x00000010,
     CHECKSUM_FLAG__ALL  = 0x7fffffff
 
 } ChecksumFlag;
@@ -832,7 +834,7 @@ typedef struct _SnortConfig
 #endif
 
     /* The port-rule-maps map the src-dst ports to rules for
-     * udp and tcp, for Ip we map the dst port as the protocol,
+     * udp, tcp, & sctp; for Ip we map the dst port as the protocol,
      * and for Icmp we map the dst port to the Icmp type. This
      * allows us to use the decode packet information to in O(1)
      * select a group of rules to apply to the packet.  These
@@ -843,6 +845,7 @@ typedef struct _SnortConfig
     PORT_RULE_MAP *prmIpRTNX;
     PORT_RULE_MAP *prmTcpRTNX;
     PORT_RULE_MAP *prmUdpRTNX;
+    PORT_RULE_MAP *prmSctpRTNX;
     PORT_RULE_MAP *prmIcmpRTNX;
 
 #ifdef TARGET_BASED
@@ -894,6 +897,7 @@ typedef struct _PacketCount
     uint64_t other;
     uint64_t tcp;
     uint64_t udp;
+    uint64_t sctp;
     uint64_t icmp;
     uint64_t arp;
 #ifndef NO_NON_ETHER_DECODER
@@ -908,8 +912,10 @@ typedef struct _PacketCount
     uint64_t icmp6;
     uint64_t tdisc;
     uint64_t udisc;
+    uint64_t sctpdisc;
     uint64_t tcp6;
     uint64_t udp6;
+    uint64_t sctp6;
     uint64_t teredo;
     uint64_t ipdisc;
     uint64_t icmpdisc;
@@ -1252,6 +1258,16 @@ static inline int ScIcmpChecksumDrops(void)
     return snort_conf->targeted_policies[getRuntimePolicy()]->checksum_drop_flags & CHECKSUM_FLAG__ICMP;
 }
 
+static inline int ScSctpChecksums(void)
+{
+    return snort_conf->targeted_policies[getDefaultPolicy()]->checksum_flags & CHECKSUM_FLAG__SCTP;
+}
+
+static inline int ScSctpChecksumDrops(void)
+{
+    return snort_conf->targeted_policies[getRuntimePolicy()]->checksum_drop_flags & CHECKSUM_FLAG__SCTP;
+}
+
 static inline int ScIgnoreTcpPort(uint16_t port)
 {
     return snort_conf->ignore_ports[port] & PROTO_BIT__TCP;
@@ -1262,6 +1278,11 @@ static inline int ScIgnoreUdpPort(uint16_t port)
     return snort_conf->ignore_ports[port] & PROTO_BIT__UDP;
 }
 
+static inline int ScIgnoreSctpPort(uint16_t port)
+{
+    return snort_conf->ignore_ports[port] & PROTO_BIT__SCTP;
+}
+
 #ifdef MPLS
 static inline long int ScMplsStackDepth(void)
 {
diff --git a/src/target-based/sftarget_protocol_reference.c b/src/target-based/sftarget_protocol_reference.c
index ac35314..7b986b8 100644
--- a/src/target-based/sftarget_protocol_reference.c
+++ b/src/target-based/sftarget_protocol_reference.c
@@ -42,6 +42,7 @@
 
 int16_t protocolReferenceTCP;
 int16_t protocolReferenceUDP;
+int16_t protocolReferenceSCTP;
 int16_t protocolReferenceICMP;
 
 static SFGHASH *proto_reference_table = NULL;
@@ -53,6 +54,7 @@ static char *standard_protocols[] =
     "ip",
     "tcp",
     "udp",
+    "sctp",
     "icmp",
     /* Application Protocols */
     "http",
@@ -175,6 +177,7 @@ void InitializeProtocolReferenceTable(void)
     }
     protocolReferenceTCP = FindProtocolReference("tcp");
     protocolReferenceUDP = FindProtocolReference("udp");
+    protocolReferenceSCTP = FindProtocolReference("sctp");
     protocolReferenceICMP = FindProtocolReference("icmp");
 }
 
@@ -226,6 +229,9 @@ int16_t GetProtocolReference(Packet *p)
         case IPPROTO_UDP:
             ipprotocol = protocolReferenceUDP;
             break;
+        case IPPROTO_SCTP:
+            ipprotocol = protocolReferenceSCTP;
+            break;
         case IPPROTO_ICMP:
             ipprotocol = protocolReferenceICMP;
             break;
diff --git a/src/target-based/sftarget_protocol_reference.h b/src/target-based/sftarget_protocol_reference.h
index a2979b7..b7b96d4 100644
--- a/src/target-based/sftarget_protocol_reference.h
+++ b/src/target-based/sftarget_protocol_reference.h
@@ -38,6 +38,7 @@ typedef struct _SFTargetProtocolReference
 
 extern int16_t protocolReferenceTCP;
 extern int16_t protocolReferenceUDP;
+extern int16_t protocolReferenceSCTP;
 extern int16_t protocolReferenceICMP;
 
 void InitializeProtocolReferenceTable(void);
diff --git a/src/util.c b/src/util.c
index 7b6d466..c38711f 100644
--- a/src/util.c
+++ b/src/util.c
@@ -1081,6 +1081,7 @@ void DropStats(int exiting)
     LogStat("ICMP", pc.icmp, total);
     LogStat("UDP", pc.udp, total);
     LogStat("TCP", pc.tcp, total);
+    LogStat("SCTP", pc.sctp, total);
 
     LogStat("IP6", pc.ipv6, total);
     LogStat("IP6 Ext", pc.ip6ext, total);
@@ -1089,6 +1090,7 @@ void DropStats(int exiting)
     LogStat("ICMP6", pc.icmp6, total);
     LogStat("UDP6", pc.udp6, total);
     LogStat("TCP6", pc.tcp6, total);
+    LogStat("SCTP6", pc.sctp6, total);
     LogStat("Teredo", pc.teredo, total);
 
     LogStat("ICMP-IP", pc.embdip, total);
@@ -1125,6 +1127,7 @@ void DropStats(int exiting)
     LogStat("TCP Disc", pc.tdisc, total);
     LogStat("UDP Disc", pc.udisc, total);
     LogStat("ICMP Disc", pc.icmpdisc, total);
+    LogStat("SCTP Disc", pc.sctpdisc, total);
     LogStat("All Discard", pc.discards, total);
 
     LogStat("Other", pc.other, total);
@@ -1841,6 +1844,120 @@ void * SnortAlloc2(size_t size, const char *format, ...)
 }
 
 /**
+ * SnortStrToNumRng - Parses a number (signed) range split by a delimiter.
+ * @str: char pointer to the string to be parsed.
+ * @delimiter: char pointer to the delimiter separating the two ranges.
+ * @rng: int pointer to the smaller value of the range.
+ *
+ * Returns:
+ *   SNORT_STR2RNG_SUCCESS is a range was successfully parsed.
+ *   SNORT_STR2RNG_NOTRNG if the range delimiter was not found.
+ *   SNORT_STR2RNG_ERROR if an error condition was encountered.
+ */
+int SnortStrToNumRng(char *str, const char *delimiter, NumericRange *rng)
+{
+    if (!str || !delimiter || !rng)
+        return SNORT_STR2RNG_ERROR;
+
+    if (SnortStrcasestr(str, strlen(str), delimiter))
+    {
+        char *tok, *end;
+        int num = 0;
+
+        /* Get the first token. */
+        tok = strtok(str, delimiter);
+        if (!tok)
+            return SNORT_STR2RNG_ERROR;
+
+        num = strtol(tok, &end, 10);
+        if (*end)
+            return SNORT_STR2RNG_ERROR;
+
+        rng->min = num;
+
+        /* Get the second token. */
+        tok = strtok(NULL, delimiter);
+        if (!tok)
+            return SNORT_STR2RNG_ERROR;
+
+        num = strtol(tok, &end, 10);
+        if (*end)
+            return SNORT_STR2RNG_ERROR;
+
+        rng->max = num;
+
+        /* See if min is > max.  If so, swap them. */
+        if (rng->min > rng->max)
+        {
+            int tmp = rng->min;
+            rng->min = rng->max;
+            rng->max = tmp;
+        }
+
+        return SNORT_STR2RNG_SUCCESS;
+    } else {
+        return SNORT_STR2RNG_NOTRNG;
+    }
+}
+
+/**
+ * SnortStrToUNumRng - Parses a number (signed) range split by a delimiter.
+ * @str: char pointer to the string to be parsed.
+ * @delimiter: char pointer to the delimiter separating the two ranges.
+ * @rng: int pointer to the smaller value of the range.
+ *
+ * Returns:
+ *   SNORT_STR2RNG_SUCCESS is a range was successfully parsed.
+ *   SNORT_STR2RNG_NOTRNG if the range delimiter was not found.
+ *   SNORT_STR2RNG_ERROR if an error condition was encountered.
+ */
+int SnortStrToUNumRng(char *str, const char *delimiter, UNumericRange *rng)
+{
+    if (!str || !delimiter || !rng)
+        return SNORT_STR2RNG_ERROR;
+
+    if (SnortStrcasestr(str, strlen(str), delimiter))
+    {
+        char *tok, *end;
+        uint32_t num = 0;
+
+        /* Get the first token. */
+        tok = strtok(str, delimiter);
+        if (!tok)
+            return SNORT_STR2RNG_ERROR;
+
+        num = strtoul(tok, &end, 10);
+        if (*end)
+            return SNORT_STR2RNG_ERROR;
+
+        rng->min = num;
+
+        /* Get the second token. */
+        tok = strtok(NULL, delimiter);
+        if (!tok)
+            return SNORT_STR2RNG_ERROR;
+
+        num = strtoul(tok, &end, 10);
+        if (*end)
+            return SNORT_STR2RNG_ERROR;
+
+        rng->max = num;
+
+        /* See if min is > max.  If so, swap them. */
+        if (rng->min > rng->max)
+        {
+            uint32_t tmp = rng->min;
+            rng->min = rng->max;
+            rng->max = tmp;
+        }
+
+        return SNORT_STR2RNG_SUCCESS;
+    } else {
+        return SNORT_STR2RNG_NOTRNG;
+    }
+}
+
+/**
  * Chroot and adjust the snort_conf->log_dir reference
  *
  * @param directory directory to chroot to
diff --git a/src/util.h b/src/util.h
index f49c606..be07567 100644
--- a/src/util.h
+++ b/src/util.h
@@ -74,6 +74,10 @@
 
 #define SNORT_STRNLEN_ERROR -1
 
+#define SNORT_STR2RNG_SUCCESS 0
+#define SNORT_STR2RNG_ERROR -1
+#define SNORT_STR2RNG_NOTRNG -2
+
 #define SECONDS_PER_DAY  86400  /* number of seconds in a day  */
 #define SECONDS_PER_HOUR  3600  /* number of seconds in a hour */
 #define SECONDS_PER_MIN     60     /* number of seconds in a minute */
@@ -172,6 +176,19 @@ typedef struct _IntervalStats
 
 } IntervalStats;
 
+/* Used by rule keywords that involve number ranges. */
+typedef struct _NumericRange
+{
+    int min;
+    int max;
+} NumericRange;
+
+typedef struct _UNumericRange
+{
+    uint32_t min;
+    uint32_t max;
+} UNumericRange;
+
 
 /* Public function prototypes *************************************************/
 int DisplayBanner(void);
@@ -226,6 +243,8 @@ const char *SnortStrnStr(const char *s, int slen, const char *searchstr);
 const char *SnortStrcasestr(const char *s, int slen, const char *substr);
 void *SnortAlloc(unsigned long);
 void *SnortAlloc2(size_t, const char *, ...);
+int SnortStrToNumRng(char *, const char *, NumericRange *);
+int SnortStrToUNumRng(char *, const char *, UNumericRange *);
 char *CurrentWorkingDir(void);
 char *GetAbsolutePath(char *dir);
 char *StripPrefixDir(char *prefix, char *dir);
